#include <Wt/WBootstrapTheme.h>
#include <Wt/WCssTheme.h>
#include <Wt/WEnvironment.h>
#include "DebugApp.h"
#include "views/ViewTopLevel.h"


DebugAppClass::DebugAppClass(const WEnvironment& env)  : WApplication(env)
{
	// BOOTSTRAP THEME
    auto bootstrapTheme = std::make_shared<WBootstrapTheme>();
    bootstrapTheme->setVersion(BootstrapVersion::v3);
    bootstrapTheme->setResponsive(true);
    setTheme(bootstrapTheme);
    useStyleSheet("resources/themes/bootstrap/3/bootstrap-theme.min.css");

	// POLISHED THEME
//    setCssTheme("polished");
//    useStyleSheet("css/style.css");


	messageResourceBundle().use("strings");
    messageResourceBundle().use("templates");

    auto currentWidget = cpp14::make_unique<ViewTopLevel>();

    root()->addWidget(std::move(currentWidget));
}

  
DebugAppClass::~DebugAppClass()
{
	// TBD Add code here to explicitly destroy stuff

}

