/*
 * Copyright (C) 2012 Emweb bv, Herent, Belgium.
 *
 * See the LICENSE file for terms of use.
 */
#include <Wt/WServer.h>

#include <mongoc/mongoc.h>

#include "DebugApp.h"



std::unique_ptr<WApplication> createApplication(const WEnvironment &env)
{
	return cpp14::make_unique<DebugAppClass>(env);
}

int main(int argc, char **argv)
{
	mongoc_init();

	try
	{
		WServer server(argc, argv, WTHTTP_CONFIGURATION);

		server.addEntryPoint(EntryPointType::Application, createApplication);

		//   Session::configureAuth();

		server.run();
	} catch (WServer::Exception &e)
	{
		std::cerr << e.what() << std::endl;
	} catch (std::exception &e)
	{
		std::cerr << "exception: " << e.what() << std::endl;
	}

	mongoc_cleanup();

}
