
 /*
 * Copyright (C) 2020 MGP Systems, LLC
 *
 * All Rights reserved.
 */

#ifndef TOP_LEVEL_SIGNALS_H__
#define TOP_LEVEL_SIGNALS_H__



// These signals are used to communicate between views
enum class SignalId
{
	//These are from the Login/Register View
	SIGNAL_BTN_LOGIN_CLICKED=0x100,
	SIGNAL_BTN_REGISTER_CLICKED,
	SIGNAL_BTN_FORGOT_PWD_CLICKED,

	// These are from the OfficeStaff Main View
	SIGNAL_BTN_VIEW_USERS_CLICKED,
	SIGNAL_BTN_MANAGE_VEHICLES_CLICKED,
	SIGNAL_BTN_MANAGE_DEVICES_CLICKED,
	SIGNAL_BTN_MANAGE_TRIPS_CLICKED,
	SIGNAL_BTN_GEN_REPORTS_CLICKED,
	SIGNAL_BTN_BILLING_CLICKED,
	SIGNAL_BTN_BACK_CLICKED,
	SIGNAL_BTN_LOGOUT_CLICKED,



	//Add new values above this line
	LAST_SIGNAL_ID_VALUE
};


enum class ViewId
{
	VIEW_ID_LOGIN_REGISTER = 0x1,
	VIEW_ID_REGISTER,
	VIEW_ID_OFFICE_STAFF_MAIN,
	VIEW_ID_IT_ADMIN_MAIN,
	VIEW_ID_DRIVER_MAIN,


	//Add new values above this line
	LAST_VIEW_ID_VALUE
};



#endif /* end of TOP_LEVEL_SIGNALS_H__ */

