#include <Wt/WPanel.h>
#include <Wt/WText.h>
#include <Wt/WImage.h>
#include <Wt/WLink.h>
#include <Wt/WVBoxLayout.h>
#include <Wt/WHBoxLayout.h>
#include <Wt/WCssDecorationStyle.h>
#include <Wt/WBorder.h>
#include <Wt/WColor.h>
#include <Wt/WFont.h>
#include <Wt/WIntValidator.h>
#include <Wt/WLineEdit.h>
#include <Wt/WLabel.h>
#include <Wt/WPushButton.h>

#include "ViewLoginRegister.h"


using namespace Wt;

LoginRegisterWidget::LoginRegisterWidget(Wt::WString fullName)
{
   //LAYOUT
  auto vboxLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
  vboxLayout->setSpacing(20);
 
   //Header 
  auto headerPanel = Wt::cpp14::make_unique<Wt::WPanel>();
  auto logoImage1 = Wt::cpp14::make_unique<Wt::WImage>("icons/java-logo.png");
  logoImage1->setMaximumSize(600,160);
  headerPanel->setMinimumSize(600,180);
  headerPanel->setMaximumSize(1200,200);

  headerPanel->setCentralWidget(std::move(logoImage1));


  //container1
  auto container1 = Wt::cpp14::make_unique<Wt::WContainerWidget>();

  auto container1A = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  auto container1B = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  auto hboxLayout1 = container1->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());
  auto gridLayout1A = container1A->setLayout(Wt::cpp14::make_unique<Wt::WGridLayout>());
  hboxLayout1->setSpacing(40);
  gridLayout1A->setHorizontalSpacing(30);
  gridLayout1A->setVerticalSpacing(20);


  // These items will go into the Grid Layout
  auto labelUserId = Wt::cpp14::make_unique<Wt::WLabel>("UserId:");
  auto labelPasswd = Wt::cpp14::make_unique<Wt::WLabel>("Password:");
 

  gridLayout1A->addWidget(std::move(labelUserId),0,0 ); //row0 column0
 // gridLayout1A->addWidget(std::move(lineEditUserId),0,1 ); //row0 column1
  lineEditUserId = gridLayout1A->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Enter UserId   "),0,1 ); //row0 column1


  gridLayout1A->addWidget(std::move(labelPasswd),1,0 ); //row0 column2
 // gridLayout1A->addWidget(std::move(lineEditPasswd),1,1 ); //row1 column0
  lineEditPasswd = gridLayout1A->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Enter Password "),1,1 ); //row1 column0

 
  auto pushBtnLogin = Wt::cpp14::make_unique<Wt::WPushButton>(" Login");
  pushBtnLogin->setMinimumSize(180,180);
//connect buttons to handler functions
  pushBtnLogin->clicked().connect(this, &LoginRegisterWidget::buttonLoginWasPressed);


  container1B->addWidget(std::move(pushBtnLogin));


  hboxLayout1->addWidget(std::move(container1A));
  hboxLayout1->addWidget(std::move(container1B));


  lineEditUserId->setWidth(450);
  lineEditUserId->setHeight(80);
  lineEditPasswd->setWidth(450);
  lineEditPasswd->setHeight(80);
  lineEditPasswd->setEchoMode(Wt::EchoMode::Password);



  //Container4
  auto container4 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  auto hboxLayout4 = container4->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());
  auto panel4 = Wt::cpp14::make_unique<Wt::WPanel>();
  auto pushBtnRegister = Wt::cpp14::make_unique<Wt::WPushButton>(" Register");
  auto pushBtnForgotPwd = Wt::cpp14::make_unique<Wt::WPushButton>(" Forgot Password");

  pushBtnRegister->setHeight(80);
  pushBtnForgotPwd->setHeight(80);

//connect buttons to handler functions
  pushBtnRegister->clicked().connect(this, &LoginRegisterWidget::buttonRegisterWasPressed);
  pushBtnForgotPwd->clicked().connect(this, &LoginRegisterWidget::buttonForgotPwdWasPressed);

  hboxLayout4->addWidget(std::move(pushBtnRegister));
  hboxLayout4->addWidget(std::move(pushBtnForgotPwd));

  // ITEM IN LAYOUT 
  vboxLayout->addWidget(std::move(headerPanel));
  vboxLayout->addWidget(std::move(container1));
  vboxLayout->addWidget(std::move(container4));

}


void LoginRegisterWidget::buttonLoginWasPressed()
{
	loginButtonClicked_.emit(lineEditUserId->text().toUTF8(), lineEditPasswd->text().toUTF8());
	//log("info") << "LoginRegisterWidget:" << "userId:= " <<  lineEditUserId->text() << " Pwd:= " <<  lineEditPasswd->text();

}


void LoginRegisterWidget::buttonRegisterWasPressed()
{
	otherButtonClicked_.emit(ViewId::VIEW_ID_LOGIN_REGISTER, SignalId::SIGNAL_BTN_REGISTER_CLICKED);
}



void LoginRegisterWidget::buttonForgotPwdWasPressed()
{
	otherButtonClicked_.emit(ViewId::VIEW_ID_LOGIN_REGISTER, SignalId::SIGNAL_BTN_FORGOT_PWD_CLICKED);
}


