/*
 * Copyright (C) 2020 MGP Systems, LLC
 *
 * All Rights reserved.
 */

#ifndef VIEW_LOGIN_REGISTER_H__
#define VIEW_LOGIN_REGISTER_H__

#include <Wt/WContainerWidget.h>
#include "ViewRegister.h"
#include "TopLevelSignals.h"
#include <Wt/WLogger.h>


class LoginRegisterWidget : public Wt::WContainerWidget
{
public:
  LoginRegisterWidget(Wt::WString fullName);
  Wt::Signal<std::string, std::string >& loginButtonClicked() { return loginButtonClicked_; }
  Wt::Signal<ViewId, SignalId>& otherButtonClicked() { return otherButtonClicked_; }
private:
  Wt::Signal<std::string, std::string>   loginButtonClicked_;
  Wt::Signal<ViewId, SignalId>   otherButtonClicked_;

  void switchToRegistrationView();
  void throttleTimer();
  int processLoginButton();

  void buttonLoginWasPressed();
  void buttonRegisterWasPressed();
  void buttonForgotPwdWasPressed();


  //std::unique_ptr <Wt::WLineEdit> lineEditUserId; 
  //std::unique_ptr <Wt::WLineEdit> lineEditPasswd; 

  Wt::WLineEdit  *lineEditUserId;
  Wt::WLineEdit  *lineEditPasswd;
 
 
};

#endif // VIEW_LOGIN_REGISTER_H__
