
#include <Wt/WImage.h>
#include <Wt/WLink.h>
#include <Wt/WVBoxLayout.h>
#include <Wt/WHBoxLayout.h>
#include <Wt/WCssDecorationStyle.h>
#include <Wt/WBorder.h>
#include <Wt/WColor.h>
#include <Wt/WFont.h>
#include <Wt/WIntValidator.h>
#include <Wt/WLineEdit.h>
#include <Wt/WLabel.h>

#include "ViewPageHeader.h"


using namespace Wt;

PageHeaderWidget::PageHeaderWidget(Wt::WString fullName, CurrentRole userRole)
{
  // Width, Height
  this->setMaximumSize(1200,400);
  this->setOffsets(50,AllSides);
  this->decorationStyle().setBorder(Wt::WBorder(Wt::BorderStyle::Double,Wt::BorderWidth::Thick, Wt::StandardColor::Black), Wt::Side::Bottom);
   //LAYOUT
  auto headerLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());

 
  //Container1
  auto container1 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  //container1->setMaximumSize(300,300);

  auto panel1 = Wt::cpp14::make_unique<Wt::WPanel>();
  auto logoImage1 = Wt::cpp14::make_unique<Wt::WImage>("icons/java-logo.png");
  logoImage1->setMaximumSize(480,300);
  panel1->setMaximumSize(500,320);

  panel1->setCentralWidget(std::move(logoImage1));
  container1->addWidget(std::move(panel1));

  //Container2
  auto container2 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  container2->setMaximumSize(450,300);

  auto vboxLayout2 = container2->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
  panel2A = Wt::cpp14::make_unique<Wt::WPanel>();
  panel2B = Wt::cpp14::make_unique<Wt::WPanel>();

  label2A = Wt::cpp14::make_unique<Wt::WText>();
  label2B = Wt::cpp14::make_unique<Wt::WText>();



  label2A->setText(Wt::WString("Current User: ") + fullName);
  panel2A->setCentralWidget(std::move(label2A));

  this->setCurrentMode(userRole);

  panel2B->setCentralWidget(std::move(label2B));

  vboxLayout2->addWidget(std::move(panel2A));
  vboxLayout2->addWidget(std::move(panel2B));


  //Container3
  auto container3 = Wt::cpp14::make_unique<Wt::WContainerWidget>();

  auto panel3 = Wt::cpp14::make_unique<Wt::WPanel>();
  panel3->setMaximumSize(100,100);

  auto settingsImage3 = Wt::cpp14::make_unique<Wt::WImage>("icons/settings-icon.png");
  settingsImage3->setMaximumSize(80,80);

  panel3->setCentralWidget(std::move(settingsImage3));
  container3->addWidget(std::move(panel3));
 
  //ADD ITEMS to LAYOUT 
  headerLayout->addWidget(std::move(container1), 0,Wt::AlignmentFlag::Left);
  headerLayout->addWidget(std::move(container2), 0,Wt::AlignmentFlag::Center);
  headerLayout->addWidget(std::move(container3), 0,Wt::AlignmentFlag::Right );

}


void PageHeaderWidget::setCurrentUser(Wt::WString fullName)
{

   // label2A->setText(Wt::WString("Current User: ") + fullName);
   // panel2A->setCentralWidget(std::move(label2A));

}



void PageHeaderWidget::setCurrentMode(CurrentRole userRole)
{
	Wt::WString theRoleText = Wt::WString("---------");

	if (userRole == CurrentRole::ROLE_IT_ADMIN) 
	{
		theRoleText = Wt::WString("IT Admin");

	}
	else if (userRole == CurrentRole::ROLE_OFFICE_STAFF)
	{
		theRoleText = Wt::WString("Office Staff");

	}
	else if (userRole == CurrentRole::ROLE_DRIVER)
	{
		theRoleText = Wt::WString("Driver");
	}
	else
		theRoleText = Wt::WString("--------");


	label2B->setText(Wt::WString("Current Mode: ") + theRoleText);
}

