
#include <Wt/WVBoxLayout.h>
#include <Wt/WHBoxLayout.h>
#include <Wt/WImage.h>
#include <Wt/WPanel.h>
#include <Wt/WText.h>
#include <Wt/WLink.h>
#include <Wt/WVBoxLayout.h>
#include <Wt/WHBoxLayout.h>
#include <Wt/WGridLayout.h>
#include <Wt/WBorder.h>
#include <Wt/WColor.h>
#include <Wt/WFont.h>
#include <Wt/WLabel.h>
#include <Wt/WCssDecorationStyle.h>


#include "ViewRegister.h"
#include "ViewPageHeader.h"


using namespace Wt;

RegistrationViewClass::RegistrationViewClass()
{
	//LAYOUT
	auto pageLayout = Wt::cpp14::make_unique<Wt::WVBoxLayout>();
	pageLayout->setSpacing(10);
	//pageLayout->setDefaultImplementation(Wt::LayoutImplementation::JavaScript);
	//pageLayout->setDefaultImplementation(Wt::LayoutImplementation::Flex);

	//Header w LOGO
	auto headerPanel = Wt::cpp14::make_unique<Wt::WPanel>();
	auto logoImage1 = Wt::cpp14::make_unique<Wt::WImage>("icons/orubugo_logo.png");
	logoImage1->setMaximumSize(600, 160);
	headerPanel->setMinimumSize(600, 180);
	headerPanel->setMaximumSize(1200, 200);

	headerPanel->setCentralWidget(std::move(logoImage1));

	//Container1
	auto container1 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
	auto container1Layout = container1->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());

	// FONT
	WFont container1Font;
	container1Font.setFamily(FontFamily::SansSerif, "Arial");
	container1Font.setSize(16);
	//containerFont.setWeight(Wt::FontWeight::Normal);
	container1Font.setWeight(Wt::FontWeight::Bold);
	container1->decorationStyle().setFont(container1Font);  // set FONT in container object

	auto panel1 = Wt::cpp14::make_unique<Wt::WPanel>();
	auto panel1Text = Wt::cpp14::make_unique<Wt::WText>("NEW USER REGISTRATION PAGE");
	panel1->setCentralWidget(std::move(panel1Text));

	container1Layout->addWidget(std::move(panel1), 0, Wt::AlignmentFlag::Center);

	//Container2
	auto container2 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
	auto container2Layout = container2->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());

	// FONT
	WFont container2Font;
	container2Font.setFamily(FontFamily::Monospace, "Courier");
	container2Font.setSize(12);
	container2Font.setWeight(Wt::FontWeight::Normal);
	//container2Font.setWeight(Wt::FontWeight::Bold);
	container2Font.setStyle(Wt::FontStyle::Italic);
	container2->decorationStyle().setFont(container2Font);  // set FONT in container object

	auto panel2 = Wt::cpp14::make_unique<Wt::WPanel>();
	auto panel2Text = Wt::cpp14::make_unique<Wt::WText>("Fill information in all Tabs, then Enter a registration Code and Click SUBMIT button");
	panel2->setCentralWidget(std::move(panel2Text));

	container2Layout->addWidget(std::move(panel2), 0, Wt::AlignmentFlag::Center);



	//container3
	auto container3 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
	Wt::WTabWidget *tabW = container3->addNew<Wt::WTabWidget>();


	tabW->addTab(Wt::cpp14::make_unique<RegistrationTab1>(), "Login Info", Wt::ContentLoading::Eager);
	tabW->addTab(Wt::cpp14::make_unique<RegistrationTab2>(), "Biographical", Wt::ContentLoading::Eager);
	tabW->addTab(Wt::cpp14::make_unique<RegistrationTab3>(), "Next Of Kin", Wt::ContentLoading::Eager);
	tabW->addTab(Wt::cpp14::make_unique<RegistrationTab4>(), "Other Data", Wt::ContentLoading::Eager);


	//container4
	auto container4 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
	auto container4Layout = container4->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());
	container4Layout->setSpacing(20);
	pushBtnSubmit = container4Layout->addWidget(Wt::cpp14::make_unique<Wt::WPushButton>(" SUBMIT"));
	lineEditCode = container4Layout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Enter Registration Code given "));
	pushBtnSubmit->setHeight(80);
	pushBtnSubmit->setWidth(200);
	lineEditCode->setWidth(200);
	lineEditCode->setHeight(80);

	// ITEM IN LAYOUT
	pageLayout->addWidget(std::move(headerPanel));
	pageLayout->addWidget(std::move(container1));
	pageLayout->addWidget(std::move(container2));
	pageLayout->addWidget(std::move(container3));
	pageLayout->addWidget(std::move(container4));

	this->setLayout(std::move(pageLayout));
 	this->setScrollVisibilityEnabled(true);

}




bool RegistrationViewClass::validateInput()
{

}

void RegistrationViewClass::submitButtonPressed()
{
	// Build an object and pass it along
	submitButtonClicked_.emit(std::string("oopsie1"), std::string("oopsie2"));
}

void RegistrationViewClass::switchToLoginView()
{

}



RegistrationTab1::RegistrationTab1()
{

	//auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
	//auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WGridLayout>());
	auto tabLayout = Wt::cpp14::make_unique<Wt::WGridLayout>();

	tabLayout->setHorizontalSpacing(20);
	tabLayout->setVerticalSpacing(10);

	lineEditEmailAddress = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("your email address here"), 0,1);
	lineEditPasswd = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("your passwd"),1,1);
	lineEditPasswdConfirm = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("confirm passwd"),2,1);
	lineEditFirstName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("First Name"),3,1);
	lineEditMiddleName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Middle Name"),4,1);
	lineEditLastName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Last Name"),5,1);


	lineEditPasswd->setEchoMode(Wt::EchoMode::Password);
	lineEditPasswdConfirm->setEchoMode(Wt::EchoMode::Password);


	auto labelUserId = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Email Address:"), 0,0);
	auto labelPasswd = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Password:"), 1,0);
	auto labelPasswdConfirm = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("ReEnter Password:"), 2,0);
	auto labelFirstName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("First Name:"), 3,0);
	auto labelMiddleName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Middle Name"), 4,0);
	auto labelLastName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Last Name:"), 5,0);

	this->setLayout(std::move(tabLayout));
 	this->setScrollVisibilityEnabled(true);

 
}




RegistrationTab2::RegistrationTab2()
{
	//auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
	auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WGridLayout>());

	tabLayout->setHorizontalSpacing(40);
	tabLayout->setVerticalSpacing(10);

	lineEditPhoneNumber = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("phone number +1-xxx-xxx-xxxx"),0,1);
	lineEditStreeAddress = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Street Address and Name"),1,1);
	lineEditCity = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("City"),2,1);
	lineEditStateOrProvince = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("State or Province"),3,1);
	lineEditCountry = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Country"),4,1);
	lineEditPostalOrZipCode = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("ZIP or Postal Code"),5,1);


	auto labelPhone = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Phone  +1-xxx-xxx-xxxx:       "), 0,0);
	auto labelAddress = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Street Address and Name:    "), 1,0);
	auto labelCity = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("City:                          "), 2,0);
	auto labelStateOrProvince = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("State or Province:  "), 3,0);
	auto labelCountry = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Country:                    "), 4,0);
	auto labelPostalOrZip = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Zip Code or Postal Code:"), 5,0);

 	this->setScrollVisibilityEnabled(true);

}



RegistrationTab3::RegistrationTab3()
{
	auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WGridLayout>());

	tabLayout->setHorizontalSpacing(40);
	tabLayout->setVerticalSpacing(10);

	lineEditNextOfKin1FullName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin Full Name"),0,1);
	lineEditNextOfKin1PhoneNum = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin Phone #"),1,1);
	lineEditNextOfKin1FullContactAddress = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin Contact Address"),2,1);
	lineEditNextOfKin1Relationship = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin Relationship"),3,1);
 
	lineEditNextOfKin2FullName = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin#2 Full Name"),4,1);
	lineEditNextOfKin2PhoneNum = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin#2 Phone #"),5,1);
	lineEditNextOfKin2FullContactAddress = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin#2 Contact Address"),6,1);
	lineEditNextOfKin2Relationship = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLineEdit>("Next of Kin#2 Relationship"),7,1);


	auto label0 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin Full Name:       "), 0,0);
	auto label1 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin Phone #:         "), 1,0);
	auto label2 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin Address:         "), 2,0);
	auto label3 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin Relationship:    "), 3,0);
	auto label4 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin #2 Full Name:    "), 4,0);
	auto label5 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin #2 Phone #:      "), 5,0);
	auto label6 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin #2 Address:      "), 6,0);
	auto label7 = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Next of Kin #2 Relationship: "), 7,0);

 	this->setScrollVisibilityEnabled(true);

}


RegistrationTab4::RegistrationTab4()
{
	auto tabLayout = this->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
	tabLayout->setSpacing(20);

	auto labelOtherInfo = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WLabel>("Tell us anything about yourself that you want to share"));

	textAreaOtherInfo = tabLayout->addWidget(Wt::cpp14::make_unique<Wt::WTextArea>("Use this space to tell us anything else about yourself that you want to share"));

 	this->setScrollVisibilityEnabled(true);

}


