 /*
 * Copyright (C) 2020 MGP Systems, LLC
 *
 * All Rights reserved.
 */

#ifndef VIEW_REGISTRATION_H__
#define VIEW_REGISTRATION_H__

 
#include <Wt/WContainerWidget.h>
#include "TopLevelSignals.h"
#include <Wt/WLogger.h>
#include <Wt/WContainerWidget.h>
#include <Wt/WMenuItem.h>
#include <Wt/WTabWidget.h>
#include <Wt/WTextArea.h>
#include <Wt/WSignal.h>
#include <Wt/WPushButton.h>
#include <Wt/WLineEdit.h>

class RegistrationViewClass : public Wt::WContainerWidget
{
public:
  RegistrationViewClass();
  Wt::Signal<std::string, std::string >& submitButtonClicked() { return submitButtonClicked_; }
private:
  Wt::Signal<std::string, std::string>   submitButtonClicked_;

  void switchToLoginView();
  void submitButtonPressed();

  //Biographical
  Wt::WLineEdit  *lineEditRegistrationCode;
 

  Wt::WPushButton  *pushBtnSubmit;
  Wt::WLineEdit  *lineEditCode;

  bool validateInput();

 
};



class RegistrationTab1 : public Wt::WContainerWidget
{
public:
  RegistrationTab1();

  Wt::WLineEdit  *lineEditEmailAddress;
  Wt::WLineEdit  *lineEditPasswd;
  Wt::WLineEdit  *lineEditPasswdConfirm;
  Wt::WLineEdit  *lineEditFirstName;
  Wt::WLineEdit  *lineEditMiddleName;
  Wt::WLineEdit  *lineEditLastName;
  bool validateInput();

  private:

};



class RegistrationTab2 : public Wt::WContainerWidget
{
public:
  RegistrationTab2();

  bool validateInput();

  Wt::WLineEdit  *lineEditPhoneNumber;
  Wt::WLineEdit  *lineEditStreeAddress;
  Wt::WLineEdit  *lineEditCity;
  Wt::WLineEdit  *lineEditStateOrProvince;
  Wt::WLineEdit  *lineEditCountry;
  Wt::WLineEdit  *lineEditPostalOrZipCode;


private:

};



class RegistrationTab3 : public Wt::WContainerWidget
{
public:
  RegistrationTab3();

  bool validateInput();

  //Next of Kin
  Wt::WLineEdit  *lineEditNextOfKin1FullName;
  Wt::WLineEdit  *lineEditNextOfKin1PhoneNum;
  Wt::WLineEdit  *lineEditNextOfKin1FullContactAddress;
  Wt::WLineEdit  *lineEditNextOfKin1Relationship;

  Wt::WLineEdit  *lineEditNextOfKin2FullName;
  Wt::WLineEdit  *lineEditNextOfKin2PhoneNum;
  Wt::WLineEdit  *lineEditNextOfKin2FullContactAddress;
  Wt::WLineEdit  *lineEditNextOfKin2Relationship;

  private:

};




class RegistrationTab4 : public Wt::WContainerWidget
{
public:
  RegistrationTab4();

  bool validateInput();

  //Other Info
  Wt::WTextArea  *textAreaOtherInfo;

private:

};









#endif // VIEW_REGISTRATION_H__

