#include <Wt/WPanel.h>
#include <Wt/WText.h>
#include <Wt/WImage.h>
#include <Wt/WLink.h>
#include <Wt/WVBoxLayout.h>
#include <Wt/WHBoxLayout.h>
#include <Wt/WCssDecorationStyle.h>
#include <Wt/WBorder.h>
#include <Wt/WColor.h>
#include <Wt/WFont.h>
#include <Wt/WIntValidator.h>
#include <Wt/WLineEdit.h>
#include <Wt/WLabel.h>
#include <Wt/WPushButton.h>

#include "ViewSample1.h"
#include "ViewPageHeader.h"


using namespace Wt;

ViewSample1Page::ViewSample1Page(Wt::WString fullName)
{
  

   //LAYOUT
  auto pageLayout1 = this->setLayout(Wt::cpp14::make_unique<Wt::WVBoxLayout>());
  pageLayout1->setSpacing(20);

 
	  //header
  auto pageHeader =   Wt::cpp14::make_unique<PageHeaderWidget>( fullName, CurrentRole::ROLE_IT_ADMIN );



  //Container1/header
  auto container1 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  auto container1Layout = container1->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());
 
   // FONT 
  WFont containerFont;
  containerFont.setFamily(FontFamily::SansSerif, "Arial");
  containerFont.setSize(20);
  //containerFont.setWeight(Wt::FontWeight::Normal);
  containerFont.setWeight(Wt::FontWeight::Bold);
  container1->decorationStyle().setFont(containerFont);  // set FONT in container object

  auto panel1 = Wt::cpp14::make_unique<Wt::WPanel>();
  auto panel1Text = Wt::cpp14::make_unique<Wt::WText>("MAIN MENU: IT-ADMIN");
  panel1->setCentralWidget(std::move(panel1Text));

  container1Layout->addWidget(std::move(panel1), 0,Wt::AlignmentFlag::Center );

 
  //Container2
  auto container2 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  

  auto buttonGridLayout = container2->setLayout(Wt::cpp14::make_unique<Wt::WGridLayout>());
  buttonGridLayout->setHorizontalSpacing(20);
  buttonGridLayout->setVerticalSpacing(20);

  auto pushBtn1 = Wt::cpp14::make_unique<Wt::WPushButton>(" Manage 1");
  auto pushBtn2 = Wt::cpp14::make_unique<Wt::WPushButton>(" Manage 2");
  auto pushBtn3 = Wt::cpp14::make_unique<Wt::WPushButton>(" Manage 3");
  auto pushBtn4 = Wt::cpp14::make_unique<Wt::WPushButton>(" Manage 4");
  auto pushBtn5 = Wt::cpp14::make_unique<Wt::WPushButton>(" Reports");
  auto pushBtn6 = Wt::cpp14::make_unique<Wt::WPushButton>(" Billing");

  pushBtn1->setHeight(80);
  pushBtn2->setHeight(80);
  pushBtn3->setHeight(80);
  pushBtn4->setHeight(80);
  pushBtn5->setHeight(80);
  pushBtn6->setHeight(80);


  //pushBtn1->clicked().connect(this, &MyClass::processData);

  buttonGridLayout->addWidget(std::move(pushBtn1),0,0 ); //row0 column0
  buttonGridLayout->addWidget(std::move(pushBtn2),0,1 ); //row0 column1
  buttonGridLayout->addWidget(std::move(pushBtn3),0,2 ); //row0 column2
  buttonGridLayout->addWidget(std::move(pushBtn4),1,0 ); //row1 column0
  buttonGridLayout->addWidget(std::move(pushBtn5),1,1 ); //row1 column1
  buttonGridLayout->addWidget(std::move(pushBtn6),1,2 ); //row1 column2

 
   //Container3
  auto container3 = Wt::cpp14::make_unique<Wt::WContainerWidget>();
  container3->decorationStyle().setBorder(Wt::WBorder(Wt::BorderStyle::Double,Wt::BorderWidth::Thick, Wt::StandardColor::Black), Wt::Side::Top);


  auto hboxLayout3 = container3->setLayout(Wt::cpp14::make_unique<Wt::WHBoxLayout>());
  hboxLayout3->setSpacing(20);

  auto pushBtnLogout = Wt::cpp14::make_unique<Wt::WPushButton>("Logout");
  auto pushBtnBack = Wt::cpp14::make_unique<Wt::WPushButton>(" Go Back");

  pushBtnLogout->setMinimumSize(250,80);
  pushBtnBack->setMinimumSize(250,80);
  pushBtnLogout->setMaximumSize(400,80);
  pushBtnBack->setMaximumSize(400,80);


  hboxLayout3->addWidget(std::move(pushBtnLogout), 0,Wt::AlignmentFlag::Center );
  hboxLayout3->addWidget(std::move(pushBtnBack) ,0,Wt::AlignmentFlag::Center );


 
  //ADD ITEMS to page LAYOUT 
  pageLayout1->addWidget(std::move(pageHeader));
  pageLayout1->addWidget(std::move(container1));
  pageLayout1->addWidget(std::move(container2));
  pageLayout1->addWidget(std::move(container3));

}



