 /*
 * Copyright (C) 2020 MGP Systems, LLC
 *
 * All Rights reserved.
 */

#ifndef VIEW_TOP_LEVEL_H__
#define VIEW_TOP_LEVEL_H__

#include <Wt/WContainerWidget.h>

#include <Wt/WStackedWidget.h>
#include <Wt/WSpinBox.h>
#include <CommonIncludes.h>



#include "ViewLoginRegister.h"
#include "ViewSample1.h"
#include "TopLevelSignals.h"
     

class ViewTopLevel : public Wt::WContainerWidget
{
public:
  ViewTopLevel();

  void updatePageState(int newIndex);

 
  Wt::WStackedWidget *stackedItemContainer;

  Wt::WString userFullName;
  CurrentRole curUserRole;
  LoginState userLoginState;


private:
	LoginRegisterWidget *widget0; 
	ViewSample1Page *widget1; 
 

	void processSignalFromView(ViewId whatView, SignalId whatSignal);
	void processLoginViewSignals( SignalId whatSignal);

	void processLoginSignal(std::string userId, std::string userPwd);
	void processRegisterSignal(ViewId whatView, SignalId whatSignal);
	void registerNewUser(std::string email1, std::string userPwd,  std::string phone1, std::string first, std::string middle, std::string last);



};

#endif // VIEW_TOP_LEVEL_H__

